{{
**********************************
* jvmEngine - executes bytecodes *
**********************************
}}


CON
  'first 64
  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_IOR               = $35
  Jem_ISHL              = $37
  Jem_ISHR              = $39
  Jem_IUSHR             = $3B
  Jem_IAND              = $3D
  Jem_IXOR              = $3F
  Jem_I2B               = $41
  Jem_GOTO              = $43
  Jem_INVOKEINTERFACE   = $45
  Jem_ARRAYLENGTH       = $47
  Jem_ATHROW            = $49
  Jem_CHECKCAST         = $4B
  'next 64
  Jem_INSTANCEOF        = $4D
  Jem_WIDE              = $4F
  Jem_IINC              = $51
  Jem_GETFIELD          = $53
  Jem_PUTFIELD          = $55
  Jem_NEW               = $57
  Jem_NEWARRAY          = $59
  Jem_ANEWARRAY         = $5B
  Jem_IALOAD            = $5D
  Jem_IASTORE           = $5F
  Jem_BALOAD            = $61
  Jem_BASTORE           = $63
  Jem_LDC               = $65
  Jem_LDC_W             = $67
  Jem_LDC2_W            = $69
  Jem_IMUL              = $6B
  Jem_IDIV              = $6D
  Jem_IREM              = $6F
  Jem_JSR               = $71
  Jem_RET               = $73
  Jem_TABLESWITCH       = $75
  Jem_LOOKUPSWITCH      = $77

  'exceptions
  kIllegalArgumentException  = 1
  kNullPointerException      = 2
  kIndexOutOfBoundsException = 3
  kOutOfMemoryError          = 4


OBJ

  jd:            "jvmDataAsm" 'jvm memory access object


VAR

  long  HandlerCog

                              
PUB start(addrJvmVars, addrJemCode)

  stop
  PtrJvmVars := addrJvmVars
  PtrJemCode := addrJemCode
  PtrJemCodeJmpTable := @JemCodeJmpTable
  
  HandlerCog := cognew(@handlerEntry, 0) + 1


PUB stop

  if HandlerCog
    cogstop(HandlerCog~ - 1)

{
      Jem_IADD:            jMath.jb_iadd
      Jem_ISUB:            jMath.jb_isub
      Jem_INEG:            jMath.jb_ineg
      Jem_IOR:             jLogic.jb_ior
      Jem_ISHL:            jLogic.jb_ishl
      Jem_ISHR:            jLogic.jb_ishr
      Jem_IUSHR:           jLogic.jb_iushr
      Jem_IAND:            jLogic.jb_iand
      Jem_IXOR:            jLogic.jb_ixor
      Jem_I2B:             jConvert.jb_i2b
      Jem_GOTO:            jCompareJump.jb_goto
      Jem_INVOKEINTERFACE: 'not used by linker
      Jem_ARRAYLENGTH:     jArray.jb_arraylength
      Jem_ATHROW:          jException.jb_athrow
      Jem_CHECKCAST:       jObject.jb_checkcast
      other:

  else
    case jemcode
      Jem_INSTANCEOF:      jObject.jb_instanceof
      Jem_WIDE:            'not used by linker
      Jem_IINC:            jStore.jb_iinc
      Jem_GETFIELD:        jObject.jb_getfield
      Jem_PUTFIELD:        jObject.jb_putfield
      Jem_NEW:             jObject.jb_new
      Jem_NEWARRAY:        jArray.jb_newarray
      Jem_ANEWARRAY:       jArray.jb_anewarray
      Jem_IALOAD:          jArray.jb_iaload
      Jem_IASTORE:         jArray.jb_iastore
      Jem_BALOAD:          jArray.jb_baload
      Jem_BASTORE:         jArray.jb_bastore
      Jem_LDC:             jConst.jb_ldc
      Jem_LDC_W:           jConst.jb_ldc_w
      Jem_LDC2_W:          'not used by linker
      Jem_IMUL:            jMath.jb_imul
      Jem_IDIV:            jMath.jb_idiv
      Jem_IREM:            jMath.jb_irem
      Jem_JSR:             jSubReturn.jb_jsr
      Jem_RET:             jSubReturn.jb_ret
      Jem_TABLESWITCH:     jCompareJump.jb_tableswitch
      Jem_LOOKUPSWITCH:    jCompareJump.jb_lookupswitch
      other:
  return -1
}  

DAT

JemCodeJmpTable         word    (@jb_iadd - @handlerEntry)/4          'Jem_IADD
                        word    (@jb_isub - @handlerEntry)/4          'Jem_ISUB
                        word    (@jb_ineg - @handlerEntry)/4          'Jem_INEG
                        word    (@jb_ior - @handlerEntry)/4           'Jem_IOR
                        word    (@jb_ishl - @handlerEntry)/4          'Jem_ISHL
                        word    (@jb_ishr - @handlerEntry)/4          'Jem_ISHR
                        word    (@jb_iushr - @handlerEntry)/4         'Jem_IUSHR
                        word    (@jb_iand - @handlerEntry)/4          'Jem_IAND
                        word    (@jb_ixor - @handlerEntry)/4          'Jem_IXOR

                        
DAT
{{
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
                        A S S E M B L Y   S E C T I O N

}}
handlerEntry            org     0

sendReady               mov     Tmp,PtrJemCode
                        cmp     _jemcode,#0  wz         'Z = 1 if native function was processed
        if_nz           xor     _jemcode,_jemcode       'otherwise byte code was processed
        if_z            add     Tmp,#1
                        wrbyte  _jemcode,Tmp
nothing2Process                        
:wait4jemcode           rdword  _jemcode,PtrJemCode     'wait for next jemcode or native function
                        tjz     _jemcode,#:wait4jemcode
                        cmp     _jemcode,#$100  wc      'C = 1 if byte code to process
        if_b            jmp     #doNative               'otherwise a native function to process
                        sub     _jemcode,#Jem_IADD  wc  'byte code is handled from this
        if_b            jmp     #:wait4jemcode          'not handled by this decoder
                        mov     Tmp,_jemcode
                        shl     Tmp,#1                  'jump table entries are words
                        add     Tmp,PtrJemCodeJmpTable
                        rdword  Tmp,Tmp                 'get address of jemcode handler
                        jmp     Tmp                     'handle byte code

{{
############################## JEMCODE HANDLER ################################
}}
{{
_______________________________________________________________________________
function: jb_iadd()
Integer add.

}}
jb_iadd                 call    #popi2l
                        mov     Param1,jvmResult
                        call    #popi2lAgain
                        add     Param1,jvmResult
                        call    #check4Carry
                        jmp     #pushParam1                        

{{
_______________________________________________________________________________
function: jb_isub()
Integer subtract.

}}
jb_isub                 call    #popi2l
                        mov     Param1,jvmResult
                        call    #popi2lAgain
                        sub     jvmResult,Param1
                        mov     Param1,jvmResult
                        call    #check4Carry
                        jmp     #pushParam1                        

{{
_______________________________________________________________________________
function: jb_ineg()
Integer negate.

}}
jb_ineg                 call    #popi2l
                        neg     Param1,jvmResult
                        jmp     #pushParam1

{{
_______________________________________________________________________________
function: jb_ior()
Integer bitwise or.

}}
jb_ior                  call    #pop
                        mov     Param1,jvmResult
                        call    #popAgain
                        or      jvmResult,Param1
                        jmp     #pushResult                        

{{
_______________________________________________________________________________
function: jb_ishl()
Integer shift left.

}}
jb_ishl                 call    #pop
                        mov     Param1,jvmResult
                        call    #popAgain
                        shl     jvmResult,Param1
                        jmp     #pushResult                        

{{
_______________________________________________________________________________
function: jb_ishr()
Integer arithmetic shift right.

}}
jb_ishr                 call    #pop
                        mov     Param1,jvmResult
                        call    #popAgain
                        sar     jvmResult,Param1
pushResult              mov     Param1,jvmResult        'l2i necessary?
pushParam1              call    #pushAgain
                        call    #incJvmPC
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_iushr()
Integer logical shift right.

}}
jb_iushr                call    #pop
                        mov     Param1,jvmResult
                        call    #popAgain
                        shr     jvmResult,Param1
                        jmp     #pushResult

{{
_______________________________________________________________________________
function: jb_iand()
Integer bitwise and.

}}
jb_iand                 call    #pop
                        mov     Param1,jvmResult
                        call    #popAgain
                        and     jvmResult,Param1
                        jmp     #pushResult

{{
_______________________________________________________________________________
function: jb_ixor()
Integer bitwise xor.

}}
jb_ixor                 call    #pop
                        mov     Param1,jvmResult
                        call    #popAgain
                        xor     jvmResult,Param1
                        jmp     #pushResult
                        
{{
############################### JVM FUNCTIONS #################################
The parameters of jvm functions are passed via variables like ParamX where X
is the number of parameter.

}}
{{
_______________________________________________________________________________
function: throw()
throw NullPointerException.

uses:   Tmp, jvmTmp
}}
throwNPE                mov     Param1,#kNullPointerException

{{
_______________________________________________________________________________
function: throw(exceptionNumber)
throw one of four runtime exceptions.

param:  Param1 = exceptionNumber
uses:   Tmp, jvmTmp
}}
throw                   mov     Param2,#Param1
                        mov     Param1,#jd#JVM_THROW
                        call    #readJavaIntBE
                        mov     Tmp,jvmResult
                        call    #getJvmFP
                        mov     Param1,jvmFP
                        call    #writeJavaIntBE         'write exceptionNumber to arg0 in current frame (eg. istore_0)
                        call    #getJvmPC
                        mov     jvmEP,jvmPC
                        call    #updateJvmEP            'remember where exception is thrown
                        mov     Param1,Tmp
                        add     Param1,#jd#JVM_CODE
                        call    #readJavaIntBE
                        mov     jvmPC,jvmResult
                        call    #updateJvmPC            'set new pc to method throwVMException
                        jmp     #sendReady
  
{{
_______________________________________________________________________________
function: doNative(nativeFin)
Execute a native function. Arguments for native functions are either in VP
registers or on the stack. If a native function returns a value it must be
placed on top of the stack.

param:  Param1 = id of function
uses:   jvmTmp
}}
doNative                ror     _jemcode,#8
                        cmp     _jemcode,#14  wz        'isCarry
        if_ne           jmp     #nothing2Process        'not handled by this cog
                        mov     Param1,jvmCarry
                        call    #push
                        xor     _jemcode,_jemcode
                        jmp     #sendReady 

{
  case nm_function
     2: arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_writeObject(arg0,arg1)
     3: arg0 := js.pop
        nm_core_CPU_delay(arg0)
     4: arg1 := js.pop
        arg0 := js.pop
        comm.message(arg0,arg1)
     5: nm_page_
     6: arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_count(arg0,arg1,arg2)
     7: arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        retval := nm_core_CPU_rcTime(arg0,arg1,arg2)
        js.push(retval)
     8: arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        retval := nm_core_CPU_pulseIn(arg0,arg1,arg2)
        js.push(retval)
     9: arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_pulseOut(arg0,arg1)
    10: arg0 := js.pop
        retval := nm_core_CPU_readPin(arg0)
        js.push(retval)
    11: arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_writePin(arg0,arg1)
    12: arg3 := js.pop
        arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        retval := nm_core_CPU_shiftIn(arg0,arg1,arg2,arg3)
        js.push(retval)
    13: arg4 := js.pop
        arg3 := js.pop
        arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_shiftOut(arg0,arg1,arg2,arg3,arg4)
    15: nm_page_
    16: arg0 := js.pop
        nm_core_CPU_uninstall(arg0)
    17: arg0 := js.pop
        nm_core_CPU_install(arg0)
    18: arg0 := js.pop
        nm_core_CPU_nap(arg0)
    19: arg0 := js.pop
        nm_core_CPU_setOutput(arg0)
    20: nm_page_
    21: arg0 := js.pop
        nm_core_CPU_setInput(arg0)
    22: nm_page_
    23: arg0 := js.pop
        retval := nm_core_CPU_readSRAM(arg0)
        js.push(retval)
    24: nm_page_
    25: arg1 := js.pop
        arg0 := js.pop
        nm_core_CPU_writeSRAM(arg0,arg1)
    26: nm_page_
    27: arg0 := js.pop
        retval := nm_core_EEPROM_eeRead(arg0)
        js.push(retval)
    28: nm_page_
    29: arg1 := js.pop
        arg0 := js.pop
        nm_core_EEPROM_eeWrite(arg0,arg1)
    30: nm_page_
    31: arg0 := js.pop
        jv.nm_core_Uart_txInit(arg0)
    32: arg0 := js.pop
        jv.nm_core_Uart_rxInit(arg0)
    33: arg0 := js.pop
        retval := jv.nm_core_Uart_rxRead(arg0)
        js.push(retval)
    34: nm_core_Callback_returnTwo
    35: arg0 := js.pop
        jv.nm_core_Timer_init(arg0)
    36: arg0 := js.pop
        jv.nm_core_Timer_latch(arg0)
    37: nm_page_
    38: arg0 := js.pop
        jv.nm_core_PWM_install(arg0)
    39: nm_page_
    40: arg4 := js.pop
        arg3 := js.pop
        arg2 := js.pop
        arg1 := js.pop
        arg0 := js.pop
        jv.nm_core_PWM_updateInternal(arg0,arg1,arg2,arg3,arg4)
    41: nm_page_
    42: arg0 := js.pop
        jv.nm_core_DAC_install(arg0)
    43: nm_page_
    44: arg0 := js.pop
        jv.nm_core_ADC_install(arg0)
    45: nm_page_
    46: retval := comm.getByte
        js.push(retval)
    47: nm_page_
}
doNative_ret            ret

{{
_______________________________________________________________________________
function: chkCarry(value)
Checks the value .

return: Param1 = value form stack
}}
chkCarry
chkCarry_ret

{{
_______________________________________________________________________________
function: pop()
Pop word from the stack.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
pop                     call    #getJvmSP
{{
_______________________________________________________________________________
function: popAgain()
Pop word from the stack if the jvmSP is already available.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
popAgain                call    #decJvmSP2
                        mov     Param1,jvmSP
                        call    #readJavaIntBE
pop_ret
popAgain_ret            ret

{{
_______________________________________________________________________________
function: popi2l()
Pop word from the stack and convert it to signed long.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
popi2l                  call    #pop
                        jmp     #popi2lInternal

{{
_______________________________________________________________________________
function: popi2lAgain()
Pop word from the stack if the jvmSP is already available
and convert it to signed long.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
popi2lAgain             call    #popAgain
popi2lInternal          mov     Param1,jvmResult
                        call    #i2l
popi2l_ret
popi2lAgain_ret         ret

{{
_______________________________________________________________________________
function: push(value)
Push word onto the stack.

param:  Param1 = value
uses:   jvmTmp, Param2
}}
push                    mov     Param2,Param1
                        call    #getJvmSP
{{
_______________________________________________________________________________
function: pushAgain(value)
Push word onto the stack if the jvmSP is already available.

param:  Param2 = value
uses:   jvmTmp, Param1
}}
pushAgain               mov     Param1,jvmSP
                        call    #writeJavaIntBE
                        call    #incJvmSP2
push_ret
pushAgain_ret           ret

{{
_______________________________________________________________________________
function: readJavaByte(address)
read value from java program.

param:  Param1 = address
return: jvmResult = value read
uses:   jvmTmp
}}
readJavaByte            call    #getJavaProg
                        mov     jvmTmp,javaProg
                        add     jvmTmp,Param1
                        rdbyte  jvmResult,jvmTmp
                        and     jvmResult,#$FF
readJavaByte_ret        ret

{{
_______________________________________________________________________________
function: readJavaIntBE(address)
read value from java program using big endian.

param:  Param1 = address
return: jvmResult = value read
uses:   jvmTmp
}}
readJavaIntBE           call    #getJavaProg
                        mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        rdbyte  jvmResult,jvmTmp
                        add     jvmTmp,#jd#JVM_INT_SIZE/2
                        shl     jvmResult,#8
                        rdbyte  jvmTmp,jvmTmp
                        or      jvmResult,jvmTmp
                        and     jvmResult,MASK_WORD
readJavaIntBE_ret       ret

{{
_______________________________________________________________________________
function: writeJavaIntBE(address, value)
write value to java program using big endian.

param:  Param1 = address
        Param2 = value
uses:   jvmTmp
}}
writeJavaIntBE          call    #getJavaProg
                        mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        ror     Param2,#8
                        wrbyte  Param2,jvmTmp
                        add     jvmTmp,#jd#JVM_INT_SIZE/2
                        rol     Param2,#8
                        wrbyte  Param2,jvmTmp
writeJavaIntBE_ret      ret

{{

############################# INTERNAL FUNCTIONS ##############################
}}
{{
_______________________________________________________________________________
function: b2i(value)
value is a signed 1 byte constant: if value < 128 const = value
                                   else const = value | $FF00.

param:  Param1 = value
return: Param1 = converted value
}}
b2i                     cmp     Param1,#128  wc
        if_nc           or      Param1,MASK_WORD_HBYTE
b2i_ret                 ret

{{
_______________________________________________________________________________
function: i2l(value)
value is a signed 2 byte constant: if value < 32768 const = value
                                   else const = value | $FFFF_0000.

param:  jvmResult = value
return: jvmResult = converted value
}}
i2l                     cmp     jvmResult,K32768  wc
        if_nc           or      jvmResult,MASK_LONG_HWORD
i2l_ret                 ret

{{
_______________________________________________________________________________
function: check4Carry(value)
set carry depending on value, 0 if value is positive or $FF if value is
negative. 

param:  Param1 = value
}}
check4Carry             and     Param1,K32768  wz       'Z = 1 if positive value
                        muxnz   jvmCarry,#$FF           'otherwise it's negative, set $FF                                   
check4Carry_ret         ret

{{
_______________________________________________________________________________
function: getJavaProg()
get address of java program storage area from main memory.

return: javaProg
uses:   jvmVar
}}
getJavaProg             mov     jvmVar,#jd#varJavaProg
                        call    #getJvmVar
                        mov     javaProg,jvmVar
getJavaProg_ret         ret

{{
_______________________________________________________________________________
function: getJvmEP()
get exception program counter from main memory.

return: jvmEP
uses:   jvmVar
}}
getJvmEP                mov     jvmVar,#jd#varJvmEP
                        call    #getJvmVar
                        mov     jvmEP,jvmVar
getJvmEP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmFP()
update exception program counter in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmEP             mov     jvmTmp,jvmEP
                        mov     jvmVar,#jd#varJvmEP
                        call    #updateJvmVar
updateJvmEP_ret         ret

{{
_______________________________________________________________________________
function: getJvmFP()
get frame pointer from main memory.

return: jvmFP
uses:   jvmVar
}}
getJvmFP                mov     jvmVar,#jd#varJvmFP
                        call    #getJvmVar
                        mov     jvmFP,jvmVar
getJvmFP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmFP()
update frame pointer in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmFP             mov     jvmTmp,jvmFP
                        mov     jvmVar,#jd#varJvmFP
                        call    #updateJvmVar
updateJvmFP_ret         ret

{{
_______________________________________________________________________________
function: getJvmMP()
get method pointer from main memory.

return: jvmMP
uses:   jvmVar
}}
getJvmMP                mov     jvmVar,#jd#varJvmMP
                        call    #getJvmVar
                        mov     jvmMP,jvmVar
getJvmMP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmMP()
update method pointer in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmMP             mov     jvmTmp,jvmMP
                        mov     jvmVar,#jd#varJvmMP
                        call    #updateJvmVar
updateJvmMP_ret         ret

{{
_______________________________________________________________________________
function: getJvmPC()
get program counter from main memory.

return: jvmPC
uses:   jvmVar
}}
getJvmPC                mov     jvmVar,#jd#varJvmPC
                        call    #getJvmVar
                        mov     jvmPC,jvmVar
getJvmPC_ret            ret

{{
_______________________________________________________________________________
function: incJvmPC()
increments program counter by 1.

uses:   jvmTmp, jvmVar
}}
incJvmPC                call    #getJvmPC
incJvmPCAgain           add     jvmPC,#1
updateJvmPC             mov     jvmTmp,jvmPC
                        mov     jvmVar,#jd#varJvmPC
                        call    #updateJvmVar
incJvmPC_ret
incJvmPCAgain_ret
incJvmPC2Again_ret
incJvmPC3_ret
incJvmPC3Again_ret
addN2JvmPC_ret
addN2JvmPCAgain_ret
updateJvmPC_ret         ret

{{
_______________________________________________________________________________
function: incJvmPC2()
increments program counter by 2.

uses:   jvmTmp, jvmVar
}}
incJvmPC2Again          add     jvmPC,#2
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: incJvmPC3()
increments program counter by 3.

uses:   jvmTmp, jvmVar
}}
incJvmPC3               call    #getJvmPC
incJvmPC3Again          add     jvmPC,#3
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: addN2JvmPC(diff)
adds given diff to program counter.

param:  jvmTmp = diff to add
uses:   jvmVar
}}
addN2JvmPC              call    #getJvmPC
addN2JvmPCAgain         add     jvmPC,jvmTmp
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: getJvmSP()
get stack pointer from main memory.

return: jvmSP
uses:   jvmVar
}}
getJvmSP                mov     jvmVar,#jd#varJvmSP
                        call    #getJvmVar
                        mov     jvmSP,jvmVar
getJvmSP_ret            ret

{{
_______________________________________________________________________________
function: decJvmSP2()
decrements stack pointer by 2 and updates it in main memory.

uses:   jvmTmp, jvmVar
}}
decJvmSP2               sub     jvmSP,#2
                        jmp     #updateJvmSP

{{
_______________________________________________________________________________
function: incJvmSP2()
increments stack pointer by 2 and updates it in main memory.

uses:   jvmTmp, jvmVar
}}
incJvmSP2               add     jvmSP,#2
updateJvmSP             mov     jvmTmp,jvmSP
                        mov     jvmVar,#jd#varJvmSP
                        call    #updateJvmVar
decJvmSP2_ret
incJvmSP2_ret
updateJvmSP_ret         ret

{{
_______________________________________________________________________________
function: getJvmVar(variable)
get a jvm variable from main memory.

param:  jvmVar = variable to get
return: jvmVar = value of jvm variable
}}
getJvmVar               add     jvmVar,PtrJvmVars
                        rdword  jvmVar,jvmVar
                        and     jvmVar,MASK_WORD
getJvmVar_ret           ret

{{
_______________________________________________________________________________
function: updateJvmVar(variable, value)
updates a jvm variable in main memory with the given value.

param:  jvmVar = variable to update
        jvmTmp = value to set
uses:   jvmVar
}}
updateJvmVar            add     jvmVar,PtrJvmVars
                        wrword  jvmTmp,jvmVar
updateJvmVar_ret        ret


K32768                  long    $8000
MASK_WORD               long    $FFFF
MASK_WORD_HBYTE         long    $FF00
MASK_LONG_HWORD         long    $FFFF_0000
PtrJemCodeJmpTable      long    0-0
PtrJemCode              long    0-0
PtrJvmVars              long    0-0

'                        long    $88338833[20]          'currently are 22 longs left
_jemcode                res     1
Param1                  res     1
Param2                  res     1
Tmp                     res     1
jvmResult               res     1
jvmTmp                  res     1
jvmVar                  res     1
javaProg                res     1
jvmEP                   res     1
jvmFP                   res     1
jvmMP                   res     1
jvmPC                   res     1
jvmSP                   res     1
jvmCarry                res     1
                        fit     $1F0
'      